/* TestRen.c
 * 
 * Copyright (C) 2001 Simone Piccardi
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/****************************************************************
 *
 * Program TestRen.c: 
 * Program to test function rename
 *
 * Author: Simone Piccardi
 * Oct. 2001
 *
 * Usage: testrem -h give all info's
 *
 * $Id: TestRen.c,v 1.4 2003/05/02 09:55:14 piccardi Exp $
 *
 ****************************************************************/
/* 
 * Include needed headers
 */
#include <errno.h>       /* error definitions and routines */ 
#include <stdlib.h>      /* C standard library */
#include <unistd.h>      /* unix standard library */
#include <stdio.h>	 /* standard I/O library */
#include <string.h>      /* string functions */

/* Help printing routine */
void usage(void);

int main(int argc, char *argv[])
{
/* 
 * Variables definition  
 */
    int i;
    char *buf,*copy;
    /*
     * Input section: decode command line parameters 
     * Use getopt function
     */
    buf = malloc(100);

    opterr = 0;	 /* don't want writing to stderr */
    while ( (i = getopt(argc, argv, "h")) != -1) {
	switch (i) {
	/* 
	 * Handling options 
	 */ 
	case 'h':   /* help option */
	    printf("Wrong -h option use\n");
	    usage();
	    return -1;
	    break;
	case '?':   /* unrecognized options */
	    printf("Unrecognized options -%c\n",optopt);
	    usage();
	default:    /* should not reached */
	    usage();
	}
    }
    /* ***********************************************************
     * 
     *		 Options processing completed
     *
     *		      Main code beginning
     * 
     * ***********************************************************/
    /* There must be 2 remaing parameters */
    if ( (argc-optind) != 2 )  {
	printf("From %d arguments, removed %d options\n", argc, optind);
	usage();
    }
    if ( rename(argv[optind], argv[optind+1]) ) {
	copy = strerror_r(errno, NULL, 0);
	perror("cannot rename");
	exit(1);
    }
    return 0;
}
/*
 * routine to print usage info and exit
 */
void usage(void) {
    printf("Program testren : test renaming of file/directories  \n");
    printf("Usage:\n");
    printf("  testrem [-h] fileorig filedest \n");
    printf("  -h	   print this help\n");
    
    exit(1);
}

